<?php

/*
 * Plugin Name:       Rumage Page
 * Plugin URI:        https://rumage.com/rumage-pages-plugin
 * Description:       Include secondhand product listings from Rumage on your website using shortcodes. See settings for more info.
 * Version:           1.0.0
 * Requires at least: 5.2
 * Requires PHP:      7.2
 * Author:            Stephen Homan-Berry
 * Author URI:        https://rumage.com/
 * License:           GPL v2 or later
 * License URI:       https://www.gnu.org/licenses/gpl-2.0.html
  * Text Domain:       rumage-pages-plugin
 * Domain Path:       /languages
 */


 function rumage_page_shortcode( $atts = [], $content = null, $tag = '' ) {
	// normalize attribute keys, lowercase
	$atts = array_change_key_case( (array) $atts, CASE_LOWER );

	// override default attributes with user attributes
	$rumage_atts = shortcode_atts(
		array(
			'page' => 'second-hand-apple-iphones2',
            'width' => '100%',
            'height' => '1200px',
            'ref' => urlencode(get_bloginfo( 'name' ))
		), $atts, $tag
	);

    $o = '';
    $url = 'https://app.rumage.com/products/'.$rumage_atts['page'].'/raw/?ref='.$rumage_atts['ref'];
    $o .= '<embed type="text/html" width="'.$rumage_atts['width'].'" height="'.$rumage_atts['height'].'" src="'.$url.'"/>';
    $o .= '<div style="width:'.$rumage_atts['width'].';text-align:right;display:block;"><a href="https://app.rumage.com"><img src="https://rumage-images.s3.eu-west-1.amazonaws.com/powered/PoweredByRumage.png" width="160px"/></a></div>';
	return $o;
}

/**
 * Central location to create all shortcodes.
 */
function rumage_shortcodes_init() {
	add_shortcode( 'rumage', 'rumage_page_shortcode' );
}

add_action( 'init', 'rumage_shortcodes_init' );



function rumage_admin_actions() {
    add_options_page(
        'Rumage Pages', 
        'Rumage Pages', 
        'manage_options', 
        'Rumage_Pages', 
        'rumage_options_callback'
    ); 
}
function rumage_options_callback()
{
    $landingpages = [];
    
    $o = file_get_contents(plugin_dir_path( __FILE__ ).'rumage-howto.html');
    
    $page = 1;

    do {

        $pageslist = json_decode(file_get_contents('http://rumage.com/wp-json/wp/v2/landingpage/?page='.$page.'&per_page=100'));
        $pagecount = rumage_get_total_pages($http_response_header);

        $landingpages = array_merge($landingpages, rumage_get_pages($pageslist));
        $page++;

    } while ($page < $pagecount);

    $o .= '<table class="widefat fixed" cellspacing="0"><tbody>';

    foreach($landingpages as $landingpage) {
        $o .= '<tr><td class="column-columnname">'.$landingpage.'</td></tr>';
    }

    $o .= '</tbody></table>';
    echo $o;
    
}
add_action('admin_menu', 'rumage_admin_actions'); 

function rumage_get_total_pages($response_headers) {
    $pagecount = intval(substr($response_headers[16],17));
    return $pagecount;
}

function rumage_get_pages($pageslist) {
    $publishedpages = [];
    foreach($pageslist as $pageobj) {
        if ($pageobj->status == 'publish') {
            $pageslug = substr($pageobj->link, 32, strlen($pageobj->link)-33);
            $pageslug = array_slice(explode('/', $pageslug), -1)[0];
            array_push($publishedpages, $pageslug);
        }
    }
    return $publishedpages;
}



function rumage_action_links ( $actions ) {
    $mylinks = array(
       '<a href="' . admin_url( 'options-general.php?page=Rumage_Pages' ) . '">Settings</a>',
    );
    $actions = array_merge( $actions, $mylinks );
    return $actions;
 }

add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), 'rumage_action_links' );



